package site.ycsb.db;

import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.ZooDefs;
import org.apache.zookeeper.ZooKeeper;
import site.ycsb.*;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import org.json.JSONObject;

import java.util.Vector;

public class ZookeeperClient extends DB {

  private static ZooKeeper zooKeeper;
  private static ZKConnection zkConnection;

  public void init() throws DBException {
    zkConnection = new ZKConnection();
    try {
      zooKeeper = zkConnection.connect("localhost");
    } catch (IOException | InterruptedException e) {
      e.printStackTrace();
    }
  }

  @Override
  public Status read(String table, String key, Set<String> fields, Map<String, ByteIterator> result) {
    return null;
  }

  @Override
  public Status scan(String table, String startkey, int recordcount, Set<String> fields, Vector<HashMap<String, ByteIterator>> result) {
    return null;
  }

  @Override
  public Status update(String table, String key, Map<String, ByteIterator> values) {
    return null;
  }

  @Override
  public Status insert(String table, String key,
                       Map<String, ByteIterator> values) {

    // zookeeper needs backslash for znodes
    String path = "\\" + table + "\\" + key;

    // turn entry into JSON Object since zookeeper does not support fields
    JSONObject jsonValue = new JSONObject();
    for (Map.Entry<String, ByteIterator> value : values.entrySet()) {
      jsonValue.put(value.getKey(), value.getValue().toString());
    }

    byte[] data = jsonValue.toString().getBytes(StandardCharsets.UTF_8);
    try {
      zooKeeper.create(
          path,
          data,
          ZooDefs.Ids.OPEN_ACL_UNSAFE,
          CreateMode.PERSISTENT);
    } catch (KeeperException | InterruptedException e) {
      e.printStackTrace();
      return Status.ERROR;
    }

    return Status.OK;

  }

  @Override
  public Status delete(String table, String key) {
    return null;
  }


}